## pdal 2.0.1+ds

=== plugins/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/test.cmake)

add_subdirectory(faux)
if(BUILD_PLUGIN_I3S)
    if(NOT ZLIB_FOUND)
        message(FATAL_ERROR "Can't build i3s and slpk plugins without zlib")
    endif()
    add_subdirectory(i3s)
endif()

if(BUILD_PLUGIN_CPD)
    add_subdirectory(cpd)
endif(BUILD_PLUGIN_CPD)

if(BUILD_PLUGIN_GEOWAVE)
    add_subdirectory(geowave)
endif(BUILD_PLUGIN_GEOWAVE)

if(BUILD_PLUGIN_ICEBRIDGE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build icebridge plugin without libxml2")
    endif()
    add_subdirectory(icebridge)
endif()

if(BUILD_PLUGIN_MATLAB)
    add_subdirectory(matlab)
endif()

if(BUILD_PLUGIN_MBIO)
    add_subdirectory(mbio)
endif()

if(BUILD_PLUGIN_MRSID)
    add_subdirectory(mrsid)
endif()

if(BUILD_PLUGIN_NITF)
    add_subdirectory(nitf)
endif()

if(BUILD_PLUGIN_OCI)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build OCI plugin without libxml2")
    endif()
    add_subdirectory(oci)
endif()

if(BUILD_PLUGIN_PGPOINTCLOUD)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build pgpointcloud plugin without libxml2")
    endif()
    add_subdirectory(pgpointcloud)
endif()

if(BUILD_PLUGIN_PYTHON)
    add_subdirectory(python)
endif()

if(BUILD_PLUGIN_OPENSCENEGRAPH)
    add_subdirectory(openscenegraph)
endif()

if(BUILD_PLUGIN_RDBLIB)
    add_subdirectory(rdb)
endif(BUILD_PLUGIN_RDBLIB)

if(BUILD_PLUGIN_RIVLIB)
    add_subdirectory(rxp)
endif(BUILD_PLUGIN_RIVLIB)

if(BUILD_PLUGIN_SQLITE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build sqlite plugin without libxml2")
    endif()
    add_subdirectory(sqlite)
endif()

if (BUILD_PLUGIN_FBX)
    add_subdirectory(fbx)
endif()

if(BUILD_PLUGIN_TILEDB)
    add_subdirectory(tiledb)
endif()

if(BUILD_PLUGIN_E57)
    add_subdirectory(e57)
endif()

=== examples/writing-writer/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(WriterTutorial)

find_package(PDAL 2.0.0 REQUIRED CONFIG)

add_library(pdal_plugin_writer_mywriter SHARED MyWriter.cpp)
target_link_libraries(pdal_plugin_writer_mywriter PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_writer_mywriter PRIVATE
    ${PDAL_INCLUDE_DIRS})

=== examples/writing/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(WritingTutorial)

find_package(PDAL 2.0.0 REQUIRED CONFIG)

add_executable(tutorial tutorial.cpp)

target_link_libraries(tutorial PRIVATE ${PDAL_LIBRARIES})
target_include_directories(tutorial PRIVATE
    ${PDAL_INCLUDE_DIRS}
    ${PDAL_INCLUDE_DIRS}/pdal)

=== plugins/e57/CMakeLists.txt ===
include(FindXercesC)
find_package(XercesC REQUIRED)

add_subdirectory(libE57Format)

PDAL_ADD_PLUGIN(e57plugin_reader reader e57
        FILES
            io/E57Reader.cpp
            io/Scan.cpp
            io/Utils.cpp
            io/Uuid.cpp
        LINK_WITH
            E57Format
            ${XercesC_LIBRARY}
)

target_include_directories(${e57plugin_reader} PRIVATE "libE57Format/include")

PDAL_ADD_PLUGIN(e57plugin_writer writer e57
        FILES
            io/E57Writer.cpp
            io/Scan.cpp
            io/Utils.cpp
            io/Uuid.cpp
        LINK_WITH
            E57Format
            ${XercesC_LIBRARY}
        )

target_include_directories(${e57plugin_writer} PRIVATE "libE57Format/include")

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_e57_read_test
            FILES
                test/E57ReaderTest.cpp
                test/ScanTest.cpp
                test/E57UtilsTest.cpp
            LINK_WITH
                ${e57plugin_reader}
                E57Format
            )
    target_include_directories(pdal_io_e57_read_test PRIVATE "libE57Format/include")

    PDAL_ADD_TEST(pdal_io_e57_write_test
        FILES
            test/E57WriterTest.cpp
            test/E57UuidTest.cpp
        LINK_WITH
            ${e57plugin_reader}
            ${e57plugin_writer}
            E57Format
            )
    target_include_directories(pdal_io_e57_write_test PRIVATE "libE57Format/include")
endif()

=== plugins/geowave/CMakeLists.txt ===
#
# GeoWave driver CMake configuration
#

include(${PDAL_CMAKE_DIR}/jni.cmake)
include(${PDAL_CMAKE_DIR}/jace.cmake)
include(${PDAL_CMAKE_DIR}/geowave.cmake)

set(GEOWAVE_LIBRARIES "")
set(GEOWAVE_LIBRARIES ${GEOWAVE_LIBRARIES} ${Boost_LIBRARIES})
set(GEOWAVE_LIBRARIES ${GEOWAVE_LIBRARIES} ${JACE_LIBRARY})
set(GEOWAVE_LIBRARIES ${GEOWAVE_LIBRARIES} ${JAVA_JVM_LIBRARY})

set(objs "")

#
# GeoWave Reader
#
set(srcs
    io/GeoWaveReader.cpp
)

set(incs
    io/GeoWaveReader.hpp
)

PDAL_ADD_PLUGIN(reader_libname reader geowave 
    FILES "${srcs}" "${incs}" 
    LINK_WITH ${GEOWAVE_LIBRARIES})

#
# GeoWave Writer
#
set(srcs
    io/GeoWaveWriter.cpp
)

set(incs
    io/GeoWaveWriter.hpp
)

PDAL_ADD_PLUGIN(writer_libname writer geowave 
    FILES "${srcs}" "${incs}" 
    LINK_WITH ${GEOWAVE_LIBRARIES})

=== plugins/i3s/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/zlib.cmake)

add_subdirectory(lepcc)

PDAL_ADD_PLUGIN(i3s_reader_libname reader i3s
    FILES
      io/I3SReader.cpp
      io/EsriUtil.cpp
      io/SlpkExtractor.cpp
      io/EsriReader.cpp
    LINK_WITH
        ${WINSOCK_LIBRARY}
        ${GDAL_LIBRARY}
        ${ZLIB_LIBRARY}
        lepcc
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${LEPCC_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${GDAL_INCLUDE_DIR}
)
target_compile_definitions(${i3s_reader_libname}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

PDAL_ADD_PLUGIN(slpk_reader_libname reader slpk
    FILES
        io/SlpkReader.cpp
        io/EsriUtil.cpp
        io/EsriReader.cpp
        io/SlpkExtractor.cpp
    LINK_WITH
        ${WINSOCK_LIBRARY}
        ${GDAL_LIBRARY}
        ${ZLIB_LIBRARY}
        lepcc
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${LEPCC_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${GDAL_INCLUDE_DIR}
)
target_compile_definitions(${slpk_reader_libname}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_slpk_reader_test
            FILES
                test/SlpkReaderTest.cpp
            LINK_WITH
                ${slpk_reader_libname}
                ${GDAL_LIBRARY}
            INCLUDES
                ${NLOHMANN_INCLUDE_DIR}
                ${PDAL_VENDOR_DIR}
                ${LEPCC_INCLUDE_DIR}
                ${PDAL_VENDOR_DIR}/eigen
                ${GDAL_INCLUDE_DIR}
    )
    target_compile_definitions(pdal_io_slpk_reader_test
        PRIVATE
            ARBITER_ZLIB
            ARBITER_DLL_IMPORT
    )

    if (BUILD_I3S_TESTS)
        PDAL_ADD_TEST(pdal_io_i3s_reader_test
                FILES
                    test/i3sReaderTest.cpp
                LINK_WITH
                    ${i3s_reader_libname}
                    ${GDAL_LIBRARY}
                INCLUDES
                    ${NLOHMANN_INCLUDE_DIR}
                    ${PDAL_VENDOR_DIR}
                    ${LEPCC_INCLUDE_DIR}
                    ${PDAL_VENDOR_DIR}/eigen
                    ${GDAL_INCLUDE_DIR}
        )
        target_compile_definitions(pdal_io_i3s_reader_test
            PRIVATE
                ARBITER_ZLIB
                ARBITER_DLL_IMPORT
        )
    endif()
endif()

=== plugins/icebridge/CMakeLists.txt ===
#
# Icebridge plugin CMake configuration
#

include (${PDAL_CMAKE_DIR}/hdf5.cmake)


if (NOT PDAL_HAVE_HDF5)
    message(FATAL "HDF5 not found but is required for Icebridge.")
else()
    PDAL_ADD_PLUGIN(libname reader icebridge
        FILES
            io/IcebridgeReader.cpp
            io/Hdf5Handler.cpp
        LINK_WITH
            ${HDF5_LIBRARIES}
        INCLUDES
            ${ROOT_DIR}
            ${LIBXML2_INCLUDE_DIR}
    )

    if (WITH_TESTS)
        PDAL_ADD_TEST(icetest
            FILES test/IcebridgeReaderTest.cpp
            LINK_WITH ${libname})
    endif()
endif()

=== plugins/rdb/CMakeLists.txt ===

find_package(rdb COMPONENTS REQUIRED)
set_package_properties(rdb PROPERTIES
    TYPE REQUIRED
    PURPOSE "Read data from RIEGL databases"
    )

PDAL_ADD_PLUGIN(libname reader rdb
    FILES
        io/RdbPointcloud.cpp
        io/RdbReader.cpp
    LINK_WITH
        rdbcpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${RDB_INCLUDE_CPP_DIR}
)
target_include_directories(${libname} PUBLIC "${PDAL_VENDOR_DIR}/eigen")

set(RDB_TEST_NAME pdal_io_rdb_reader_test)
option(BUILD_RDBLIB_TESTS "Build rdblib tests" ON)
if (BUILD_RDBLIB_TESTS)
    configure_file(
        test/Config.hpp.in
        "${CMAKE_CURRENT_BINARY_DIR}/test/Config.hpp"
    )

    PDAL_ADD_TEST(${RDB_TEST_NAME}
        FILES
            test/RdbReaderTest.cpp
        LINK_WITH
            ${libname}
        INCLUDES
            ${PROJECT_BINARY_DIR}/plugins/rdb/test
            ${PROJECT_SOURCE_DIR}/plugins/rdb/io
            ${RDB_INCLUDE_CPP_DIR}
    )
endif()

=== plugins/rxp/CMakeLists.txt ===
set(RXP_TEST_NAME rxptest)

find_package(RiVLib COMPONENTS scanlib REQUIRED)
set_package_properties(RiVLib PROPERTIES
    TYPE REQUIRED
    PURPOSE "Read data from RIEGL sensors"
    )

PDAL_ADD_PLUGIN(libname reader rxp
    FILES
        io/RxpPointcloud.cpp
        io/RxpReader.cpp
    LINK_WITH
        ${RiVLib_SCANLIB_LIBRARY}
    INCLUDES
        ${RiVLib_INCLUDE_DIRS}
)

option(BUILD_RIVLIB_TESTS "Build rivlib tests" ON)
if (BUILD_RIVLIB_TESTS)
    configure_file(
        test/Config.hpp.in
        "${CMAKE_CURRENT_BINARY_DIR}/test/Config.hpp"
    )

    PDAL_ADD_TEST(${RXP_TEST_NAME}
        FILES
            test/RxpReaderTest.cpp
        LINK_WITH
            ${libname}
        INCLUDES
            ${RiVLib_INCLUDE_DIRS}
            ${PROJECT_BINARY_DIR}/plugins/rxp/test
            ${PROJECT_SOURCE_DIR}/plugins/rxp/io
    )
endif()

=== plugins/sqlite/CMakeLists.txt ===
#
# SQLite plugin CMake configuration
#

include (${PDAL_CMAKE_DIR}/sqlite.cmake)
include (${PDAL_CMAKE_DIR}/spatialite.cmake)

# SQLite Reader
#

PDAL_ADD_PLUGIN(reader_libname reader sqlite
    FILES
        io/SQLiteCommon.cpp
        io/SQLiteReader.cpp
    LINK_WITH
        ${SQLITE3_LIBRARY}
        ${LIBXML2_LIBRARIES}
    INCLUDES
        ${LIBXML2_INCLUDE_DIR}
)

#
# SQLite Writer
#

PDAL_ADD_PLUGIN(writer_libname writer sqlite
    FILES
        io/SQLiteCommon.cpp
        io/SQLiteWriter.cpp
    LINK_WITH
        ${SQLITE3_LIBRARY}
        ${GDAL_LIBRARY}
        ${LIBXML2_LIBRARIES}
    INCLUDES
        ${GDAL_INCLUDE_DIR}
        ${LIBXML2_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
)

#
# SQLite tests
#
if(BUILD_SQLITE_TESTS)
	PDAL_ADD_TEST(sqlitetest
        FILES
            io/SQLiteCommon.cpp
            test/SQLiteTest.cpp
            test/SQLiteTest.cpp
        LINK_WITH
            ${reader_libname}
            ${writer_libname}
            ${SQLITE3_LIBRARY}
            ${LIBXML2_LIBRARY}
        INCLUDES
            ${PDAL_IO_DIR}
            ${LIBXML2_INCLUDE_DIR}
    )
endif()

=== test/unit/CMakeLists.txt ===
###############################################################################
#
# test/unit/CMakeLists.txt controls building of PDAL unit tests suite
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################

configure_file(TestConfig.hpp.in "${CMAKE_CURRENT_BINARY_DIR}/TestConfig.hpp")

file(GLOB_RECURSE inFiles RELATIVE "${CMAKE_SOURCE_DIR}" "${CMAKE_SOURCE_DIR}/test/data/*.in")
foreach(infileName ${inFiles})
    string(REGEX REPLACE ".in\$" "" outfileName "${infileName}")
    configure_file("${CMAKE_SOURCE_DIR}/${infileName}"
        "${CMAKE_BINARY_DIR}/${outfileName}")
endforeach()

add_library(${PDAL_TEST_SUPPORT_OBJS} OBJECT Support.cpp)
add_dependencies(${PDAL_TEST_SUPPORT_OBJS} generate_dimension_hpp)
target_include_directories(${PDAL_TEST_SUPPORT_OBJS}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PROJECT_BINARY_DIR}/test/unit
        ${PDAL_INCLUDE_DIR}
)
PDAL_TARGET_COMPILE_SETTINGS(${PDAL_TEST_SUPPORT_OBJS})

PDAL_ADD_TEST(pdal_bounds_test FILES BoundsTest.cpp)
PDAL_ADD_TEST(pdal_config_test FILES ConfigTest.cpp)
PDAL_ADD_TEST(pdal_eigen_test
    FILES
        EigenTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_file_utils_test FILES FileUtilsTest.cpp)
PDAL_ADD_TEST(pdal_georeference_test FILES GeoreferenceTest.cpp)
PDAL_ADD_TEST(pdal_kdindex_test
    FILES
        KDIndexTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_kernel_test FILES KernelTest.cpp)
PDAL_ADD_TEST(pdal_log_test FILES LogTest.cpp)
PDAL_ADD_TEST(pdal_metadata_test FILES MetadataTest.cpp)
PDAL_ADD_TEST(pdal_oldpclblock_test FILES OldPCLBlockTest.cpp)

PDAL_ADD_TEST(pdal_options_test
    FILES
        OptionsTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_pipeline_manager_test FILES PipelineManagerTest.cpp)
PDAL_ADD_TEST(pdal_pipeline_writer_test
    FILES
        PipelineWriterTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_plugin_manager_test FILES PluginManagerTest.cpp)
PDAL_ADD_TEST(pdal_point_view_test
    FILES
        PointViewTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_point_table_test FILES PointTableTest.cpp)

PDAL_ADD_TEST(pdal_program_arg_test
    FILES
        ProgramArgsTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_artifact_test FILES ArtifactTest.cpp)

PDAL_ADD_TEST(pdal_polygon_test
    FILES
        PolygonTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
target_include_directories(pdal_polygon_test
    PRIVATE
        ${GDAL_INCLUDE_DIR})
PDAL_ADD_TEST(pdal_segmentation_test FILES SegmentationTest.cpp)
PDAL_ADD_TEST(pdal_spatial_reference_test
    FILES
        SpatialReferenceTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
    LINK_WITH
        ${GDAL_LIBRARY}
)

PDAL_ADD_TEST(pdal_stage_factory_test FILES StageFactoryTest.cpp)
PDAL_ADD_TEST(pdal_streaming_test FILES StreamingTest.cpp)
PDAL_ADD_TEST(pdal_support_test FILES SupportTest.cpp)
PDAL_ADD_TEST(pdal_utils_test FILES UtilsTest.cpp)
PDAL_ADD_TEST(pdal_uuid_test FILES UuidTest.cpp)
if (PDAL_HAVE_LAZ_PERF)
PDAL_ADD_TEST(pdal_lazperf_test FILES LazPerfTest.cpp)
endif()
if (PDAL_HAVE_ZLIB)
PDAL_ADD_TEST(pdal_deflate_test FILES DeflateTest.cpp)
endif()
if (PDAL_HAVE_LZMA)
PDAL_ADD_TEST(pdal_lzma_test FILES LzmaTest.cpp)
endif()
if (PDAL_HAVE_ZSTD)
PDAL_ADD_TEST(pdal_zstd_test FILES ZstdTest.cpp)
endif()

#
# sources for the native io
#
PDAL_ADD_TEST(pdal_io_bpf_base_test FILES io/BpfTestBase.cpp)
if (PDAL_HAVE_ZLIB)
    PDAL_ADD_TEST(pdal_io_bpf_zlib_test FILES io/BpfTestZlib.cpp)
endif()
PDAL_ADD_TEST(pdal_io_buffer_test FILES io/BufferTest.cpp)
if (PDAL_HAVE_LASZIP)
    PDAL_ADD_TEST(pdal_io_ept_reader_test
        FILES
            io/EptReaderTest.cpp
        LINK_WITH
            ${GDAL_LIBRARY} # EptReaderTest uses the crop filter.
        INCLUDES
            ${NLOHMANN_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(pdal_io_ept_addon_writer_test
        FILES
            io/EptAddonWriterTest.cpp
        LINK_WITH
            ${GDAL_LIBRARY} # EptAddonWriterTest uses the crop filter.
        INCLUDES
            ${NLOHMANN_INCLUDE_DIR}
    )
endif(PDAL_HAVE_LASZIP)
PDAL_ADD_TEST(pdal_io_faux_test FILES io/FauxReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_gdal_reader_test
    FILES
        io/GDALReaderTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
    target_include_directories(pdal_io_gdal_reader_test
        PRIVATE
            ${GDAL_INCLUDE_DIR})

PDAL_ADD_TEST(pdal_io_gdal_writer_test
    FILES
        io/GDALWriterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
    INCLUDES
        ${GDAL_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_io_las_reader_test
    FILES
        io/LasReaderTest.cpp
)
PDAL_ADD_TEST(pdal_io_las_writer_test
    FILES
        io/LasWriterTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)

PDAL_ADD_TEST(pdal_io_optech_test FILES io/OptechReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_pcd_reader_test
    FILES
        io/PcdReaderTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_io_pcd_writer_test
    FILES
        io/PcdWriterTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_io_ply_reader_test
    FILES
        io/PlyReaderTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}
)
PDAL_ADD_TEST(pdal_io_ply_writer_test
    FILES
        io/PlyWriterTest.cpp
    INCLUDES ${PDAL_VENDOR_DIR}
)
PDAL_ADD_TEST(pdal_io_pts_reader_test FILES io/PtsReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_qfit_test FILES io/QFITReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_sbet_reader_test FILES io/SbetReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_sbet_writer_test FILES io/SbetWriterTest.cpp)
PDAL_ADD_TEST(pdal_io_terrasolid_test FILES io/TerrasolidReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_text_writer_test FILES io/TextWriterTest.cpp)
PDAL_ADD_TEST(pdal_io_text_reader_test
    FILES
        io/TextReaderTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)

#
# sources for the native filters
#
PDAL_ADD_TEST(pdal_filters_assign_test FILES filters/AssignFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_chipper_test
    FILES
        filters/ChipperTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_filters_nndistance_test
    FILES
        filters/NNDistanceTest.cpp
)
PDAL_ADD_TEST(pdal_filters_colorinterp_test
    FILES
        filters/ColorinterpFilterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
PDAL_ADD_TEST(pdal_filters_colorization_test
    FILES
        filters/ColorizationFilterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
PDAL_ADD_TEST(pdal_filters_crop_test
    FILES
        filters/CropFilterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
PDAL_ADD_TEST(pdal_filters_decimation_test FILES
    filters/DecimationFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_delaunay_test FILES filters/DelaunayFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_covariancefeatures_test FILES filters/CovarianceFeaturesTest.cpp)
PDAL_ADD_TEST(pdal_filters_divider_test FILES filters/DividerFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_mongoexpression_test
    FILES
        filters/MongoExpressionFilterTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)

PDAL_ADD_TEST(pdal_filters_ferry_test FILES filters/FerryFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_groupby_test FILES filters/GroupByFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_ht_test FILES filters/HeadTailFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_icp_test
    FILES
        filters/IcpFilterTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen
)
PDAL_ADD_TEST(pdal_filters_info_test FILES filters/InfoFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_neighborclassifier_test FILES filters/NeighborClassifierFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_locate_test FILES filters/LocateFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_merge_test FILES filters/MergeTest.cpp)
PDAL_ADD_TEST(pdal_morton_order_test FILES filters/MortonOrderTest.cpp)
PDAL_ADD_TEST(pdal_filters_additional_merge_test
    FILES
        filters/AdditionalMergeTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_filters_overlay_test FILES filters/OverlayFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_pmf_test FILES filters/PMFFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_reprojection_test FILES
    filters/ReprojectionFilterTest.cpp)
if (GDAL_3)
    PDAL_ADD_TEST(pdal_filters_projpipeline_test FILES filters/ProjPipelineFilterTest.cpp)
endif()
PDAL_ADD_TEST(pdal_filters_range_test FILES filters/RangeFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_randomize_test FILES filters/RandomizeFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_reciprocity_test FILES filters/ReciprocityFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_returns_test FILES filters/ReturnsFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_shell_test FILES filters/ShellFilterTest.cpp)

PDAL_ADD_TEST(pdal_filters_smrf_test FILES filters/SMRFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_sort_test
    FILES
        filters/SortFilterTest.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_filters_splitter_test
    FILES
        filters/SplitterTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen)
PDAL_ADD_TEST(pdal_filters_stats_test FILES filters/StatsFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_transformation_test FILES
    filters/TransformationFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_hexbin_test FILES filters/HexbinFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_voxel_test FILES filters/VoxelTest.cpp)

PDAL_ADD_TEST(pdal_app_test FILES apps/AppTest.cpp)
PDAL_ADD_TEST(pdal_app_plugin_test FILES apps/AppPluginTest.cpp)
PDAL_ADD_TEST(pdal_info_test FILES apps/InfoTest.cpp)
PDAL_ADD_TEST(pdal_tile_test FILES apps/TileTest.cpp)
PDAL_ADD_TEST(pdal_tindex_test FILES apps/TIndexTest.cpp)
if (LASZIP_FOUND)
    PDAL_ADD_TEST(pdal_merge_test FILES apps/MergeTest.cpp)
endif()
PDAL_ADD_TEST(pc2pc_test FILES apps/pc2pcTest.cpp)

if (BUILD_PIPELINE_TESTS)
    PDAL_ADD_TEST(pcpipeline_test_json FILES apps/pcpipelineTestJSON.cpp)
endif()
PDAL_ADD_TEST(hausdorff_test FILES apps/HausdorffTest.cpp)
PDAL_ADD_TEST(random_test FILES apps/RandomTest.cpp)
PDAL_ADD_TEST(translate_test FILES apps/TranslateTest.cpp)

if(PDAL_HAVE_LIBXML2)
    PDAL_ADD_TEST(pdal_io_ilvis2_metadata_test
        FILES
            io/Ilvis2MetadataReaderTest.cpp
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(pdal_io_ilvis2_reader_metadata_test
        FILES
            io/Ilvis2ReaderWithMDReaderTest.cpp
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(xml_schema_test
        FILES
            XMLSchemaTest.cpp
        LINK_WITH
            ${LIBXML2_LIBRARIES}
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(pdal_io_ilvis2_test
        FILES
            io/Ilvis2ReaderTest.cpp
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
endif()

=== vendor/gtest/CMakeLists.txt ===
########################################################################
# CMake build script for Google Test.
#
# To run the tests for Google Test itself on Linux, use 'make test' or
# ctest.  You can select which tests to run using 'ctest -R regex'.
# For more options, run 'ctest --help'.

# When other libraries are using a shared version of runtime libraries,
# Google Test also has to use one.
option(
  gtest_force_shared_crt
  "Use shared (DLL) run-time lib even when Google Test is built as static lib."
  OFF)

option(gtest_build_tests "Build all of gtest's own tests." OFF)

option(gtest_build_samples "Build gtest's sample programs." OFF)

option(gtest_disable_pthreads "Disable uses of pthreads in gtest." OFF)

option(
  gtest_hide_internal_symbols
  "Build gtest with internal symbols hidden in shared libraries."
  OFF)

# Defines pre_project_set_up_hermetic_build() and set_up_hermetic_build().
include(cmake/hermetic_build.cmake OPTIONAL)

if (COMMAND pre_project_set_up_hermetic_build)
  pre_project_set_up_hermetic_build()
endif()

########################################################################
#
# Project-wide settings

# Name of the project.
#
# CMake files in this project can refer to the root source directory
# as ${gtest_SOURCE_DIR} and to the root binary directory as
# ${gtest_BINARY_DIR}.
# Language "C" is required for find_package(Threads).
if (CMAKE_VERSION VERSION_LESS 3.0)
  project(gtest CXX C)
else()
  cmake_policy(SET CMP0048 NEW)
endif()
cmake_minimum_required(VERSION 2.6.4)

if (POLICY CMP0063) # Visibility
  cmake_policy(SET CMP0063 NEW)
endif (POLICY CMP0063)

if (COMMAND set_up_hermetic_build)
  set_up_hermetic_build()
endif()

# These commands only run if this is the main project
if(CMAKE_PROJECT_NAME STREQUAL "gtest" OR CMAKE_PROJECT_NAME STREQUAL "googletest-distribution")

  # BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
  # make it prominent in the GUI.
  option(BUILD_SHARED_LIBS "Build shared libraries (DLLs)." OFF)

else()

  mark_as_advanced(
    gtest_force_shared_crt
    gtest_build_tests
    gtest_build_samples
    gtest_disable_pthreads
    gtest_hide_internal_symbols)

endif()


if (gtest_hide_internal_symbols)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif()

# Define helper functions and macros used by Google Test.
include(cmake/internal_utils.cmake)

config_compiler_and_linker()  # Defined in internal_utils.cmake.

# Create the CMake package file descriptors.
if (INSTALL_GTEST)
  include(CMakePackageConfigHelpers)
  set(cmake_package_name GTest)
  set(targets_export_name ${cmake_package_name}Targets CACHE INTERNAL "")
  set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated" CACHE INTERNAL "")
  set(cmake_files_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${cmake_package_name}")
  set(version_file "${generated_dir}/${cmake_package_name}ConfigVersion.cmake")
  write_basic_package_version_file(${version_file} COMPATIBILITY AnyNewerVersion)
  install(EXPORT ${targets_export_name}
    NAMESPACE ${cmake_package_name}::
    DESTINATION ${cmake_files_install_dir})
  set(config_file "${generated_dir}/${cmake_package_name}Config.cmake")
  configure_package_config_file("${gtest_SOURCE_DIR}/cmake/Config.cmake.in"
    "${config_file}" INSTALL_DESTINATION ${cmake_files_install_dir})
  install(FILES ${version_file} ${config_file}
    DESTINATION ${cmake_files_install_dir})
endif()

# Where Google Test's .h files can be found.
set(gtest_build_include_dirs
  "${gtest_SOURCE_DIR}/include"
  "${gtest_SOURCE_DIR}")
include_directories(${gtest_build_include_dirs})

# Summary of tuple support for Microsoft Visual Studio:
# Compiler    version(MS)  version(cmake)  Support
# ----------  -----------  --------------  -----------------------------
# <= VS 2010  <= 10        <= 1600         Use Google Tests's own tuple.
# VS 2012     11           1700            std::tr1::tuple + _VARIADIC_MAX=10
# VS 2013     12           1800            std::tr1::tuple
# VS 2015     14           1900            std::tuple
# VS 2017     15           >= 1910         std::tuple
if (MSVC AND MSVC_VERSION EQUAL 1700)
  add_definitions(/D _VARIADIC_MAX=10)
endif()

########################################################################
#
# Defines the gtest & gtest_main libraries.  User tests should link
# with one of them.

# Google Test libraries.  We build them using more strict warnings than what
# are used for other targets, to ensure that gtest can be compiled by a user
# aggressive about warnings.
cxx_library(gtest "${cxx_strict}" src/gtest-all.cc)
cxx_library(gtest_main "${cxx_strict}" src/gtest_main.cc)
# If the CMake version supports it, attach header directory information
# to the targets for when we are part of a parent build (ie being pulled
# in via add_subdirectory() rather than being a standalone build).
if (DEFINED CMAKE_VERSION AND NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.11")
  target_include_directories(gtest SYSTEM INTERFACE
    "$<BUILD_INTERFACE:${gtest_build_include_dirs}>"
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")
  target_include_directories(gtest_main SYSTEM INTERFACE
    "$<BUILD_INTERFACE:${gtest_build_include_dirs}>"
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")
endif()
target_link_libraries(gtest_main PUBLIC gtest)

########################################################################
#
# Install rules
install_project(gtest gtest_main)

########################################################################
#
# Samples on how to link user tests with gtest or gtest_main.
#
# They are not built by default.  To build them, set the
# gtest_build_samples option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_samples=ON flag when running cmake.

if (gtest_build_samples)
  cxx_executable(sample1_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample2_unittest samples gtest_main samples/sample2.cc)
  cxx_executable(sample3_unittest samples gtest_main)
  cxx_executable(sample4_unittest samples gtest_main samples/sample4.cc)
  cxx_executable(sample5_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample6_unittest samples gtest_main)
  cxx_executable(sample7_unittest samples gtest_main)
  cxx_executable(sample8_unittest samples gtest_main)
  cxx_executable(sample9_unittest samples gtest)
  cxx_executable(sample10_unittest samples gtest)
endif()

########################################################################
#
# Google Test's own tests.
#
# You can skip this section if you aren't interested in testing
# Google Test itself.
#
# The tests are not built by default.  To build them, set the
# gtest_build_tests option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_tests=ON flag when running cmake.

if (gtest_build_tests)
  # This must be set in the root directory for the tests to be run by
  # 'make test' or ctest.
  enable_testing()

  ############################################################
  # C++ tests built with standard compiler flags.

  cxx_test(googletest-death-test-test gtest_main)
  cxx_test(gtest_environment_test gtest)
  cxx_test(googletest-filepath-test gtest_main)
  cxx_test(googletest-linked-ptr-test gtest_main)
  cxx_test(googletest-listener-test gtest_main)
  cxx_test(gtest_main_unittest gtest_main)
  cxx_test(googletest-message-test gtest_main)
  cxx_test(gtest_no_test_unittest gtest)
  cxx_test(googletest-options-test gtest_main)
  cxx_test(googletest-param-test-test gtest
    test/googletest-param-test2-test.cc)
  cxx_test(googletest-port-test gtest_main)
  cxx_test(gtest_pred_impl_unittest gtest_main)
  cxx_test(gtest_premature_exit_test gtest
    test/gtest_premature_exit_test.cc)
  cxx_test(googletest-printers-test gtest_main)
  cxx_test(gtest_prod_test gtest_main
    test/production.cc)
  cxx_test(gtest_repeat_test gtest)
  cxx_test(gtest_sole_header_test gtest_main)
  cxx_test(gtest_stress_test gtest)
  cxx_test(googletest-test-part-test gtest_main)
  cxx_test(gtest_throw_on_failure_ex_test gtest)
  cxx_test(gtest-typed-test_test gtest_main
    test/gtest-typed-test2_test.cc)
  cxx_test(gtest_unittest gtest_main)
  cxx_test(gtest-unittest-api_test gtest)

  ############################################################
  # C++ tests built with non-standard compiler flags.

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_library(gtest_no_exception "${cxx_no_exception}"
      src/gtest-all.cc)
    cxx_library(gtest_main_no_exception "${cxx_no_exception}"
      src/gtest-all.cc src/gtest_main.cc)
  endif()
  cxx_library(gtest_main_no_rtti "${cxx_no_rtti}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_test_with_flags(gtest-death-test_ex_nocatch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=0"
    gtest test/googletest-death-test_ex_test.cc)
  cxx_test_with_flags(gtest-death-test_ex_catch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=1"
    gtest test/googletest-death-test_ex_test.cc)

  cxx_test_with_flags(gtest_no_rtti_unittest "${cxx_no_rtti}"
    gtest_main_no_rtti test/gtest_unittest.cc)

  cxx_shared_library(gtest_dll "${cxx_default}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_executable_with_flags(gtest_dll_test_ "${cxx_default}"
    gtest_dll test/gtest_all_test.cc)
  set_target_properties(gtest_dll_test_
                        PROPERTIES
                        COMPILE_DEFINITIONS "GTEST_LINKED_AS_SHARED_LIBRARY=1")

  if (NOT MSVC OR MSVC_VERSION LESS 1600)  # 1600 is Visual Studio 2010.
    # Visual Studio 2010, 2012, and 2013 define symbols in std::tr1 that
    # conflict with our own definitions. Therefore using our own tuple does not
    # work on those compilers.
    cxx_library(gtest_main_use_own_tuple "${cxx_use_own_tuple}"
      src/gtest-all.cc src/gtest_main.cc)

    cxx_test_with_flags(googletest-tuple-test "${cxx_use_own_tuple}"
      gtest_main_use_own_tuple test/googletest-tuple-test.cc)

    cxx_test_with_flags(gtest_use_own_tuple_test "${cxx_use_own_tuple}"
      gtest_main_use_own_tuple
      test/googletest-param-test-test.cc test/googletest-param-test2-test.cc)
  endif()

  ############################################################
  # Python tests.

  cxx_executable(googletest-break-on-failure-unittest_ test gtest)
  py_test(googletest-break-on-failure-unittest)

  # Visual Studio .NET 2003 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)  # 1310 is Visual Studio .NET 2003
    cxx_executable_with_flags(
      googletest-catch-exceptions-no-ex-test_
      "${cxx_no_exception}"
      gtest_main_no_exception
      test/googletest-catch-exceptions-test_.cc)
  endif()

  cxx_executable_with_flags(
    googletest-catch-exceptions-ex-test_
    "${cxx_exception}"
    gtest_main
    test/googletest-catch-exceptions-test_.cc)
  py_test(googletest-catch-exceptions-test)

  cxx_executable(googletest-color-test_ test gtest)
  py_test(googletest-color-test)

  cxx_executable(googletest-env-var-test_ test gtest)
  py_test(googletest-env-var-test)

  cxx_executable(googletest-filter-unittest_ test gtest)
  py_test(googletest-filter-unittest)

  cxx_executable(gtest_help_test_ test gtest_main)
  py_test(gtest_help_test)

  cxx_executable(googletest-list-tests-unittest_ test gtest)
  py_test(googletest-list-tests-unittest)

  cxx_executable(googletest-output-test_ test gtest)
  py_test(googletest-output-test --no_stacktrace_support)

  cxx_executable(googletest-shuffle-test_ test gtest)
  py_test(googletest-shuffle-test)

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_executable(googletest-throw-on-failure-test_ test gtest_no_exception)
    set_target_properties(googletest-throw-on-failure-test_
      PROPERTIES
      COMPILE_FLAGS "${cxx_no_exception}")

=== debian/changelog ===
pdal (2.0.1+ds-1build3) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:15:15 +0100

pdal (2.0.1+ds-1build2) focal; urgency=medium

  * No-change rebuild for gdal soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jan 2020 14:34:09 +0000

pdal (2.0.1+ds-1build1) focal; urgency=medium

  * Rebuild against new libproj15.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 26 Oct 2019 13:56:32 +0200

pdal (2.0.1+ds-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 04 Sep 2019 08:38:46 +0200

pdal (2.0.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Rename library packages for SONAME bump.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 23 Aug 2019 15:37:33 +0200

pdal (2.0.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop libjsoncpp-dev build dependency, add libzstd-dev.
  * Drop greyhound plugin, removed upstream.
  * Update copyright file, changes:
    - Update copyright years for existing copyright holders
    - Add new copyright holders
    - Add license & copyright for libE57Format & CRCpp
    - Drop license & copyright for jsoncpp, removed upstream
    - Add license & copyright for nlohmann
  * Drop obsolete config.{guess,sub} update for gtest.
  * Drop unused override for spelling-error-in-binary.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 23 Aug 2019 07:07:55 +0200

=== debian/control ===
Source: pdal
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Build-Depends: debhelper (>= 9),
               dh-python,
               autotools-dev,
               bash-completion,
               chrpath,
               cmake (>= 3.5),
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libgdal-dev (>= 2.2),
               libgeotiff-dev,
               libhdf5-dev,
               libjs-mathjax,
               liblaszip-dev,
               libpq-dev,
               libproj-dev,
               libspatialite-dev,
               libsqlite3-dev,
               libsqlite3-mod-spatialite,
               libwebsocketpp-dev,
               libxml2-dev,
               libzstd-dev,
               pkg-kde-tools,
               python3-all-dev,
               python3-breathe,
               python3-numpy,
               python3-sphinx,
               python3-sphinx-bootstrap-theme,
               zlib1g-dev,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pdal
Vcs-Git: https://salsa.debian.org/debian-gis-team/pdal.git
Homepage: http://pdal.io/

Package: pdal
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL utilities.

Package: pdal-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${sphinxdoc:Depends},
         ${misc:Depends}
Suggests: libpdal-dev,
          pdal
Description: Point Data Abstraction Library - documentation
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL documentation.

Package: libpdal-base9
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libpdal-plugins
Description: Point Data Abstraction Library - libpdal_base
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_base shared library.

Package: libpdal-util9
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - libpdal_util
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_util shared library.

Package: libpdal-dev
Architecture: any
Section: libdevel
Depends: libpdal-base9 (= ${binary:Version}),
         libpdal-util9 (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev,
         libgeos++-dev,
         libgeotiff-dev,
         liblaszip-dev,
         libproj-dev,
         libxml2-dev,
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library - development files
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL development files.

Package: libpdal-plugins
Architecture: any
Section: libs
Depends: libpdal-plugin-faux (= ${binary:Version}),
         libpdal-plugin-icebridge (= ${binary:Version}),
         libpdal-plugin-pgpointcloud (= ${binary:Version}),
         libpdal-plugin-python (= ${binary:Version}),
         libpdal-plugin-sqlite (= ${binary:Version}),
         ${misc:Depends}
Description: Point Data Abstraction Library - plugins
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This metapackage depends on the individual PDAL plugin packages.

Package: libpdal-plugin-faux
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Faux plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Faux plugin.

Package: libpdal-plugin-icebridge
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Icebridge plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Icebridge plugin.

Package: libpdal-plugin-pgpointcloud
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - PostgreSQL PointCloud plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PostgreSQL PointCloud plugin.

Package: libpdal-plugin-python
Architecture: any
Section: libs
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libpdal-plugin-numpy (<< 1.7.2-2~)
Replaces: libpdal-plugin-numpy (<< 1.7.2-2~)
Description: Point Data Abstraction Library - Python plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Python plugin.

Package: libpdal-plugin-sqlite
Architecture: any
Section: libs
Depends: libsqlite3-mod-spatialite,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - SQLite plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/pkg-info.mk

CXXFLAGS += $(CPPFLAGS)

UPSTREAM_VERSION  = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE = $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES := $(wildcard debian/man/*.*.xml)

%:
	dh $@ --with python3,pkgkde_symbolshelper,sphinxdoc --parallel

override_dh_clean:
	dh_clean debian/man/*.1

	$(RM) -r doc/html

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                     -DCMAKE_INSTALL_LIBDIR=lib \
	                     -DBUILD_PLUGIN_ICEBRIDGE=ON \
	                     -DBUILD_PLUGIN_PYTHON=ON \
	                     -DBUILD_PLUGIN_SQLITE=ON \
	                     -DWITH_COMPLETION=ON

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build

	sphinx-build doc/ doc/html/ && ln -s /usr/share/javascript/mathjax doc/html/_static/

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Exclude tests:
	# - pgpointcloudtest, requires configured PostgreSQL database
	# - pdal_spatial_reference_test, fails sometimes
	(cd obj-* && ctest --force-new-ctest-process --output-on-failure --exclude-regex "pgpointcloudtest|pdal_spatial_reference_test" || echo "Ignoring test failures")
endif

override_dh_auto_install:
	dh_auto_install

	# Strip RPATH
	chrpath --delete debian/tmp/usr/lib/libpdal_plugin_*.so

	# Move pkg-config file to Multi-Arch path
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_install:
	dh_install --list-missing

override_dh_python3:
	dh_python3 -plibpdal-plugin-python
	dh_numpy3 -plibpdal-plugin-python

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*?)?(?:rel|v|PDAL)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/PDAL-$1.$2/,\
repacksuffix=+ds \
https://github.com/PDAL/PDAL/releases \
(?:.*?/archive/)?(?:rel|v|PDAL)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
